
var 
k_h i k_f zeta k
s v vstar c lambda
l w m pi b
q bstar_p psi r rstar
ge y gam qm mc
gam_h gam_f ca x xstar
bstar bstar_g gdp gm
;

varexo eRs eVs eXs eKs;

parameters
delta omega_k phi_l eta phi_m
beta omega_b phi alpha omega_p
theta_p xi theta psi_bar zeta_bar
pistar ge_bar rstar_bar xstar_bar vstar_bar

//---- Steady-state values
k_h_ss i_ss k_f_ss k_ss s_ss
v_ss c_ss lambda_ss l_ss w_ss
m_ss pi_ss b_ss q_ss bstar_p_ss
r_ss y_ss gam_ss qm_ss mc_ss
gam_h_ss gam_f_ss ca_ss x_ss bstar_ss
bstar_g_ss gdp_ss gm_ss 
 
//--- Parameters related to shock processes (autocorrelations and standard deviations)
rho_rs rho_vs rho_xs rho_ks
sigma_rs sigma_vs sigma_xs sigma_ks;

//----------------------------------------------------------------
//-- Calibrate parameters 
//----------------------------------------------------------------
[param, ss] = abc;
delta=param(1);
omega_k=param(2);
phi_l=param(3);
eta=param(4); 
phi_m=param(5);
beta=param(6);
omega_b=param(7);
phi=param(8);
alpha=param(9); 
omega_p= param(10);
theta_p=param(11);
xi=param(12);
theta=param(13);
psi_bar=param(14);
zeta_bar=param(15);

//---Steady state values
k_h_ss = ss(1);
i_ss = ss(2);
k_f_ss = ss(3);
k_ss = ss(4);
s_ss = ss(5);
v_ss = ss(6);
vstar_bar = ss(7);
c_ss = ss(8);
lambda_ss = ss(9);
l_ss = ss(10);
w_ss = ss(11);
m_ss = ss(12);
pi_ss = ss(13);
pistar = ss(14);
b_ss = ss(15);
q_ss = ss(16);
bstar_p_ss = ss(17);
r_ss = ss(18);
rstar_bar = ss(19);
ge_bar = ss(20);
y_ss = ss(21);
gam_ss = ss(22);
qm_ss = ss(23);
mc_ss = ss(24);
gam_h_ss = ss(25);
gam_f_ss = ss(26);
ca_ss = ss(27);
x_ss = ss(28);
xstar_bar = ss(29);
bstar_ss = ss(30);
bstar_g_ss = ss(31);
gdp_ss = ss(32);
gm_ss = ss(33);
psi_ss=psi_bar;
zeta_ss=zeta_bar;

//--- Parameters in shock processes 
rho_rs = 0.98;      
rho_vs = 0.98;          
rho_xs = 0.95; 
rho_ks = 0.95;    
sigma_rs = 0.01;  
sigma_vs = 0.01;  
sigma_xs = 0.01; 
sigma_ks = 0.01; 


model;

//Eq (1): ʱ
k_h_ss*k_h = (1-delta)*k_h_ss*k_h(-1) + i_ss*i;

//Eq (2): FDI
k_f = rho_ks*k_f(-1) + eKs; 

//Eq (3): ʱݶ
zeta_bar*k_h_ss*(zeta+k_h) + zeta_bar*k_f_ss*(zeta+k_f)=k_h_ss*k_h;

//Eq (4): ʱ
k_ss*k = k_h_ss*k_h + k_f_ss*k_f;

//Eq (5): ʱѡ1
s + (omega_k*(zeta_bar)^2-omega_k*zeta_bar)*zeta = v;

//Eq (6): ʱѡ2
omega_k*s_ss*zeta_bar*zeta = vstar_bar*vstar - v_ss*v;

//Eq (7): v*
vstar = rho_vs*vstar(-1) + eVs; 

//Eq (8): ծȯͶʱ
(psi_bar*b_ss+psi_bar*q_ss*bstar_p_ss)*psi+
psi_bar*b_ss*b+psi_bar*q*bstar_p_ss*(bstar_p+q)=b_ss*b;

//Eq (9): ҷ
m = m(-1) + gm - pi;

//Eq (10): ѵı߼Ч
lambda = -c;

//Eq (11):Ͷѡ
w = eta*l-lambda;

//Eq (12): 
(phi_m/m_ss)*m + lambda_ss*lambda - beta*lambda_ss/pi_ss*(lambda(+1)-pi(+1))=0;

//Eq (13): Ͷʵŷ
lambda(+1) - lambda + r - pi(+1) = omega_b*psi_bar*(1-psi_bar)*psi;

//Eq (14): ƽ
beta*r_ss/pi_ss*r - beta*rstar_bar*ge_bar/pi_ss*(rstar+ge(+1)) = omega_b*psi_bar*psi;

//Eq (15): 
y=phi*gam + alpha*(1-phi)*l + (1-alpha)*(1-phi)*k(-1);

//Eq (16): Ͷ
w = mc + y - l;

//Eq (17): мƷ
qm = mc + y - gam;

//Eq (18): ɱСµı߼ʳɱ
mc = phi*qm + (1-alpha)*(1-phi)*s(-1) + alpha*(1-phi)*w;

//Eq (19): µı߼ʳɱ
theta_p*mc_ss*y_ss*mc - omega_p*c_ss*pi + beta*omega_p*c_ss*pi(+1)=0;

//Eq (20): мƷ
gam = xi*gam_h + (1-xi)*gam_f;

//Eq (21): ʵʻʶ
q-q(-1)=ge-pi;

//Eq (22): мƷ
q = gam_h - gam_f;

//Eq (23): мƷ
qm = (1-xi)*q;

//Eq (24): ˻
ca_ss*ca = x_ss*x - q_ss*gam_f_ss*(q+gam_f)+
q_ss*bstar_ss*(rstar_bar-1)/pistar*(bstar(-1)+q)+
q_ss*bstar_ss*rstar_bar/pistar*rstar(-1)+
k_f_ss*(1-vstar_bar)*k_f(-1)-k_f_ss*vstar_bar*vstar(-1);

//Eq (25): R*
rstar = rho_rs*rstar(-1) + eRs; 

//Eq (26): 
x = xstar+theta*q;

//Eq (27): X*
xstar = rho_xs*xstar(-1) + eXs; 

//Eq (28): ˻
ca_ss*ca = q_ss*bstar_ss*(1-1/pistar)*q+
q_ss*bstar_ss*bstar-q_ss*bstar_ss/pistar*bstar(-1)+
k_f_ss*(k_f(-1)-k_f);

//Eq (29): ٵԤԼ 
q_ss*bstar_g_ss*(1-rstar_bar/pistar)*q + 
q_ss*bstar_g_ss*bstar_g - q_ss*rstar_bar*bstar_g_ss/pistar*(rstar(-1)+bstar_g(-1)) = 
b_ss*b + r_ss*b_ss/pi_ss*(r(-1)-b(-1)) + m_ss*m - m_ss/pi_ss*m(-1) + (r_ss*b_ss+m_ss)/pi_ss*pi;

//Eq (30): Ʒгľ
y_ss*y = c_ss*c + x_ss*x + gam_h_ss*gam_h + i_ss*i;

//Eq (31): Թծȯ
bstar_ss*bstar = bstar_p_ss*bstar_p + bstar_g_ss*bstar_g;

//Eq (32): gdp
gdp_ss*gdp = c_ss*c + x_ss*x -q_ss*gam_f_ss*(q+gam_f);

//Eq(33): PEG
ge = 0;

end;

shocks;
var eRs; stderr sigma_rs;
var eXs; stderr sigma_xs; 
end;

//use Ramsey optimal policy
//define planner objective, which corresponds to utility function of agents
planner_objective c + log(c_ss) - (phi_l*l_ss^(1+eta)/(1+eta))*(1+(1+eta)*l) + phi_m*(m+log(m_ss));

//set up Ramsey optimal policy problem with interest rate R as the instrument,...
// defining the discount factor in the planner objective to be the one of private agents        
ramsey_model(instruments=(r),planner_discount=beta,planner_discount_latex_name=$\beta$); 

//conduct stochastic simulations of the Ramsey problem
stoch_simul(order=1,irf=20,periods=500) pi q;
evaluate_planner_objective;